#ifndef _Scan_IDL
#define _Scan_IDL

#include <acscomponent.idl>
#include "tnrtAntenna.idl"
#include "ScanError.idl"

#pragma prefix "alma"
/**
Structure of Scan follows the vocuabulary and concept from the document 
APEX-MPI-ICD-002 (rev 1.67, year 2018)
Atacama Pathfinder EXperiment: Multi-Beam FITS Raw Data Format
Authors: Dirk Muders, Edward Polehampton and Jennifer Hatchell

This IDL makes data available to publish through DataAggregator and Backend.metadata_server.
Data piplelines will use this data to write various file types (MBFITS, ALMATI-FITS, Gildas CLASS)


--- copy and paste from APEX 2018 document -------------------------------------------------------------- 
Extracted from the ALMA Software Glossary (via ALMA-TI FITS definition, Lucas & Glendenning 2001):

*dump*:  The smallest interval of time for which a set of correlated data can be accumulated and
output from the correlator.

*integration*: A set of dumps, all identical in configuration (except for the antenna motion and
some others), that is accumulated and forms the basic recorded unit.

*subscan*: A set of integrations while the antennas complete an elemental pattern across the
source, possibly while frequency switching, nutator (hexapod) switching, etc. (previous to v.1.54:
observation)

*scan*: A set of subscans with a common goal, for example, a pointing scan, a focus scan, or an
atmospheric amplitude calibration scan, or a correlation scan on a continuum source or a
line source.

For instance in the case of holography measurements a subscan would be a drift across the
transmitter or a bore-sight measurement, while a scan could be the whole set of subscans needed
to acquire a beam map. Or a scan could be a pointing scan with two subscans (an azimuth
drift and an elevation drift across the pointing calibrator) or an atmospheric calibration scan
with three subscans (autocorrelations on the sky, and two loads at different temperatures, ...).
A scan can be as simple as a short integration on a celestial source while total power and/or
correlator output are recorded; or it could be a set of pointed subscans that are used together
to form a map of an extended celestial source.
Here are some examples of how this scheme works for single dish observing.

Examples of a scan:
– An on-the-fly map of an astronomical source, including associated sky off subscans
– A raster map . . .
– A pointing scan (cross-raster or cross-OTF)
– A focus scan
– A skydip
– A flux calibration measurement
– Five on-source measurements forming a cross and a sky off position
– A holography measurement

Examples of a subscan:
– A line of an OTF map
– One sample in a raster
– A sample on a sky off position
– A heterodyne calibration (HOT/COLD/SKY)
– One step in a focus scan

...

– Scan:
The scan is the lowest level object normally used by an observer. It is a sequence of one or more
*subscans* that share a single goal: for instance pointing and focus scans involve a pattern of
*subscans*. Whether OTF mosaicing observations are considered a single scan or a scan per point
is rather a matter of how you would like to define it.
– *Subscan*:
A *subscan* is the minimal amount of data taking that can be commanded at the script language
level. It is highly desirable that it should be a simple enough element so that the script language
may be used to define the content of scans (at the staff member/expert level), as a means to develop
and debug new observing modes.

----------- End copy - paste -------------------------------------------------------------------

This Scan component defines data structures to implement many types of scans and move data
to other ACS components via IDL.  

Scan component also maintains a queue of scans to be observed.  
ObsEngine reads from this queue when it is activated in AUTO mode.  

The actual implementation of Scans and Subscans exist in separate Python classes which 
inherit common properties and functions from parent classes AbstractBaseScan and AbstractBaseSubscan
*/

module ScanMod
{
	/**
	Enumerated types for lists of options that require strict type checking.
	*/
	enum PrimaryAxis{axis_x, axis_y};

	typedef sequence<string> ListOfStrings;

	// ------------------------------------------------------
	// Data types for user input parameters to create scan
	// ------------------------------------------------------
	/** Use CORBA valuetype instead of struct because valuetypes can inherit from base value types.
		structs cannot inherit from parent.
		OmniORB translates this IDL valuetype into a Python class that inherits
		from base class. 
		*/

	valuetype ScheduleParams{
		public string project_id;		// MBFITS key PROJID max length=20
		public string obs_id;			// MBFITS key OBSID max length=24
		public unsigned long scan_id;	// MBFITS key SCANNUM
		public double priority;			// for insert to priority queue
		public double start_mjd;		// MBFITS key MJD
		public string source_name;		// MBFITS key OBJECT max length=30
		public string line_name;		// MBFITS key MOLECULE | TRRANSITI max length=20
		};

	/** Base interfaces and inheritance
		Note (SS. 05/2020) - In other programming languages, I would like to use the keyword "abstract" 
		in abstract base class declaration to prevent creation of an instance object.
		However IDL abstract valuetypes cannot have state variables.  only functions.
		Therefore, these valuetypes are not declared abstract.  An instance of one of these Base 
		valuetypes does not have meaning.  Sub value types should be created as instances.
		Base value types are used to enforce type checking on function addScan and reduce 
		COPY+PASTE code for common parameters.

		Note (SS. 05/2020): 
		The parameter configurations in AbstractScantypeParams and subclasses are
		comparable to the MBFITS keywords Scantype, SCANMODE, SCANGEOM explained in 
		the specification document section 19.2 "Scanning / mapping description".
		Since each Scantype has different spec of required and optional parameters, 
		I have chosen this implementation of parent / sub valuetypes.  

		Each subclass of AbstractScantypeParams includes all of the appropriate MBFITS-style params 
		for Scantype, SCANMODE, SCANGEOM

		OmniORB compiles these valuetypes and generates Python classes of each valuetype.  
		Python can take care of optional parameters in each class.  
		IDL can take care of type checking objects passing as parameter to functions.
		*/

	/** Calibration Reference Coordinate types.

		AbstractScantypeParams objects that require a reference coordinate cannot use 
		AbstractCalCoordParams.  They must use one of the fully-implemented child-classes 
		to create the correct scan pattern: {CalCoordParamsHO or CalCoordParamsEQ}

		AbstractScantypeParams objects that require a CalCoord for calibration are:
			- ScantypeParamsCalColdload
			- ScantypeParamsCalHotload
			- ScantypeParamsCalNoise

		AbstractScantypeParams objects that allow optional calibration coordinate can use
		the implemented child classes to add calibration subscans to the scan pattern
		at the at the reference coordinate.  If the optional calibration coordinates are not
		provided by the user, AbstractCalCoordParams will be used as a placeholder 
		for CORBA IDL function call. The factory functions in scantype_models.py will not 
		add calibration subscans if it finds AbstractCalCoordParams instead of 
		{CalCoordParamsHO or CalCoordParamsEQ}

		AbstractScantypeParams objects that allow optional off-source Calibration Coordinate are:
			- ScantypeParamsCross
			- ScantypeParamsFivePoint
			- ScantypeParamsOnSource
			- ScantypeParamsRaster

		AbstractScantypeParams objects that do not use Calibration Coordinate are:
			- ScantypeParamsFocus
			- ScantypeParamsManual
			- ScantypeParamsMap
			- ScantypeParamsSkydip
			- ScantypeParamsTimeSync
		*/

	valuetype AbstractCalCoordParams{};

	/* Extend the emtpy type to include useful data*/
	valuetype CalCoordParams: AbstractCalCoordParams{
		public double dx;
		public double dy;
		public double duration;
		public tnrtAntennaMod::cmdTrackMode coord_system;
		};

	valuetype AbstractScantypeParams{};

	valuetype ScantypeParamsCalColdload: AbstractScantypeParams{
		public double time_per_phase;
		public CalCoordParams cal_coord_params;
		};

	valuetype ScantypeParamsCalHotload: AbstractScantypeParams{
		public double time_per_phase;
		public CalCoordParams cal_coord_params;
		};

	valuetype ScantypeParamsCalNoise: AbstractScantypeParams{
		public double time_per_phase;
		public CalCoordParams cal_coord_params;
		};

	valuetype ScantypeParamsCross: AbstractScantypeParams{
		public double arm_length;
		public double time_per_arm;
		public long win_min;		// window to gaussian fit pointing data at end of scan [arcsec]
		public long win_max;		// window to gaussian fit pointing data at end of scan [arcsec]
		public boolean double_cross; // scan the cross in both directions?
		public AbstractCalCoordParams cal_coord_params;
		};

	valuetype ScantypeParamsFivePoint: AbstractScantypeParams{
		public double arm_length;
		public double time_per_point;
		public long win_min;		// window to gaussian fit pointing data at end of scan [arcsec]
		public long win_max;		// window to gaussian fit pointing data at end of scan [arcsec]
		public AbstractCalCoordParams cal_coord_params;
		};

	valuetype ScantypeParamsFocus: AbstractScantypeParams{
		public tnrtAntennaMod::hxpAxis axis;
		public double start_pos;
		public double end_pos;
		public double velocity;
		};

	valuetype ScantypeParamsMap: AbstractScantypeParams{
		public double line_length;
		public double time_per_line;
		public long nlines;
		public double spacing;
		public PrimaryAxis axis;
		public boolean zigzag;
		public tnrtAntennaMod::cmdTrackMode coord_system;
		public long subscans_per_cal;
		public double time_cal0;
		public double time_per_cal;
		};

	valuetype ScantypeParamsManual: AbstractScantypeParams{
		public double duration;
		};

	valuetype ScantypeParamsOnSource: AbstractScantypeParams{
		public double duration;
		public AbstractCalCoordParams cal_coord_params;
		};

	valuetype ScantypeParamsRaster: AbstractScantypeParams{
		public double xlen;
		public double xstep;
		public double ylen;
		public double ystep;
		public double time_per_point;
		public boolean zigzag;
		public PrimaryAxis primary_axis;
		public tnrtAntennaMod::cmdTrackMode coord_system;
		public AbstractCalCoordParams cal_coord_params;
		};

	valuetype ScantypeParamsSkydip: AbstractScantypeParams{
		public double az;
		public double el_start;
		public double el_end;
		public double duration;
		};

	valuetype ScantypeParamsTimeSync: AbstractScantypeParams{
		public double duration;
		};

	/** No data in parent class.  
		It is used for type-checking parameters that could be any of the child classes at runtime
		In good object-oriented design, we should keep the common tracking parameters in this parent 
		class.  However, OmniORB builds Python modules that require the common parameters to be the  
		first mandatory parameters when creating the object in a single command line.  This is opposite
		to the nash.TrackingParamsXXX classes that have user_pointing_correction as last paramter to be optional
		in Python.  So, create a common parameters struct and include it at the end of the parameter list.
		We can deal with the optional bit at nash level where we handle all parameters.
		*/
	valuetype AbstractTrackingParams{};

	valuetype TrackingParamsCommon{
		public double user_pointing_correction_az;
		public double user_pointing_correction_el;
		public double elevation_min;
		public double elevation_max;
		public boolean north_crossing;
		public boolean use_horizontal_tables;
		public long max_tracking_errors;
		};
	
	valuetype TrackingParamsHO: AbstractTrackingParams{
		public double az;
		public double el;
		public TrackingParamsCommon common;
		};

	valuetype TrackingParamsTLE: AbstractTrackingParams{
		public string tle_line0;
		public string tle_line1;
		public string tle_line2;
		public TrackingParamsCommon common;
		};

	valuetype TrackingParamsEQ: AbstractTrackingParams{
		public double ra;
		public double dec;
		public double pm_ra;
		public double pm_dec;
		public double parallax;
		public double radial_velocity;
		public boolean send_icrs_to_acu;
		public TrackingParamsCommon common;
		};

	valuetype TrackingParamsSS: AbstractTrackingParams{
		public string planet;
		public TrackingParamsCommon common;
		// add any other user parameters here?
		};

	/** No data in parent class.  
		Use for type-checking parameters at runtime that must be one of the child classes
		*/
	valuetype AbstractFrontendParams{};

	valuetype FrontendParamsL: AbstractFrontendParams{
		// TODO add some parameters
		
		};

	valuetype FrontendParamsCX: AbstractFrontendParams{
		// TODO add some parameters
		};

	valuetype FrontendParamsKu: AbstractFrontendParams{
		// TODO add some parameters
		};

	valuetype FrontendParamsK: AbstractFrontendParams{
		public boolean auto_enable_lna;
		};

	valuetype FrontendParamsOptical: AbstractFrontendParams{
		// TODO add some parameters
		};

	valuetype AbstractBackendParams{};

	valuetype BackendParamsEDD: AbstractBackendParams{
		public string preset_config_name;
		public string kwargs_json;
		public boolean mock;
		};

	valuetype BackendParamsHoloFFT: AbstractBackendParams{
		public string preset_config_name;
		public string kwargs_json;
		};

	valuetype BackendParamsHoloSDR: AbstractBackendParams{
		public string preset_config_name;
		public string kwargs_json;
		};

	valuetype BackendParamsSKARAB: AbstractBackendParams{
		public string preset_config_name;
		public string kwargs_json;
		};

	valuetype BackendParamsOptical: AbstractBackendParams{
		public string preset_config_name;
		public string kwargs_json;
		};

	valuetype BackendParamsPowerMeter: AbstractBackendParams{
		public string preset_config_name;
		public string kwargs_json;
		};

	valuetype DataParams{
		public ListOfStrings pipeline_name_list;
		};

	/*	Notification channel ID */
	const string CHANNEL_NAME_METADATA = "SCAN_METADATA";
	const string CHANNEL_NAME_SCHEDULE = "SCAN_SCHEDULE";
	
	/** Metadata structure for Scan metadata to publish out to MBFITS.
	Variable names copied from MBFITS-APEX-MPI-ICD-0002 v1.67, 2018-10-11 
	Section  21.3
	
	NOTE: Original MBFITS keyword "DATE-OBS" is not a valid variable name in
	C++ / Python.  Therefore, I have changed the name to DATE_OBS.
	*/
	
	struct PRIMARY_MBFITS_HEADER_TYPE{
		short NAXIS;		// type="I" value=0
		boolean SIMPLE;		// type="L" value=True
		short BITPIX;		// type="I" value=32
		boolean EXTEND;		// type="L" value=True
		string TELESCOP;	// Telescope Name type="20A" 
		string ORIGIN;		// Organisation or Institution type="20A" 
		string CREATOR;		// Software (including version)" type="20A" 
		string MBFTSVER;	// MBFITS version" type="10A"
		string COMMENT;		// type="20A"
		};

	struct SCAN_MBFITS_HEADER_TYPE{
		string EXTNAME;		// name of this table "SCAN-MBFITS"
		string TELESCOP; 	// Telescope Name, type="20A"
		double SITELONG; 	// Observatory longitude, unit="deg"
		double SITELAT; 	// Observatory latitude, unit="deg" 
		float SITEELEV;		// Observatory elevation, unit="m"
		float DIAMETER;		// Dish diameter
		string PROJID;		// Project ID" type="20A" 
		string OBSID;		// Observer and operator initials type="24A" 
		unsigned long SCANNUM;		// Scan number
		
		string TIMESYS;		// Time system (TAI, UTC, UT1, etc ...) for MJD and DATE-OBS type="04A" 
		string DATE_OBS;	// Scan start in TIMESYS system " type="23A"  format ISO-8601: CCYY-MM-DDThh:mm:ss.ssss
		double MJD;			// Scan date/time (Modified Julian Date) in TIMESYS system unit="day"
		double EQUOBS;		// (optional) Equinox of observation unit="year"
		double LST;			// Local apparent sidereal time (scan start) unit="s"
		unsigned long NOBS;			// (DEPRECATED - keep for back compatibility) replaced by NSUBS
		unsigned long NSUBS;			// Number of subscans in this scan (replaces NOBS after v1.5)
		double UTC2UT1; 	// UT1-UTC time translation unit="s" 
		double TAI2UTC;		// UTC-TAI time translation unit="s" 
		double ETUTC;		// Ephemeris Time - UTC time translation unit="s"
		double GPSTAI;		// GPS time - TAI translation unit="s" 
		
		string WCSNAME;		// Human-readable description of frame type="20A". example: "Horizontal Coordinates" 
		string RADESYS;		// Additional system definition for ecliptic/equatorial coords" type="08A" 
		float EQUINOX; 		// Equinox unit="Julian yrs"  
		string BLNGTYPE;	// Basis system type (longitude) – XLON-SFL (where x takes appropriate values) type="8A"
		string CTYPE1;		// (DEPRECATED - keep for back compatibility) replaced by BLNGTYPE
		string BLATTYPE;	// Basis system type (latitude) – XLAT-SFL (where x takes appropriate values) type="8A"
		string CTYPE2;		// (DEPRECATED - keep for back compatibility) replaced by BLATTYPE
		double NLNGZERO;	// Native frame zero in basis system (longitude)
		double CRVAL1;		// (DEPRECATED - keep for back compatibility) replaced by NLNGZERO
		double NLATZERO; 	// Native frame zero in basis system (latitude)
		double CRVAL2;		// (DEPRECATED - keep for back compatibility) replaced by NLATZERO
		string NLNGTYPE; 	// Native system type (longitude) – XLON-SFL (where x takes appropriate values) type="8A"
		string CTYPE1N;		// (DEPRECATED - keep for back compatibility) replaced by NLNGTYPE
		string NLATTYPE; 	// Native system type (latitude) – XLAT-SFL (where x takes appropriate values) type="8A"
		string CTYPE2N;		// (DEPRECATED - keep for back compatibility) replaced by NLATTYPE
		double LONPOLE;		// Native longitude of celestial pole: range -180 to +180 deg unit="deg" 
		double LATPOLE;		// Basis latitude of native pole unit="deg" 
		
		string X_OBJECT;	// Source name type="20A"
		double BLONGOBJ;	// Source longitude in basis frame unit="deg" 
		double BLATOBJ;		// Source latitude in basis frame unit="deg" 
		double LONGOBJ;		// Source longitude in user native frame unit="deg" 
		double LATOBJ;		// Source latitude in user native frame unit="deg" 
		double PATLONG;		// Pattern longitude offset in user native frame
		double PATLAT;		// Pattern latitude offset in user native frame
		string CALCODE;		// Calibrator Code type="04A" 
		
		boolean MOVEFRAM;	// True if tracking a moving frame. In the case of moving objects, the orbital elements are also stored. The abbeviations in description match JPL Horizons.
		double PERIDATE;	// TP, Full Julian date of perihelion unit="Julian days"
		double PERIDIST; 	// QR, perihelion distance unit="AU" 
		double LONGASC;		// OM, Longitude of ascending node unit="deg"
		double OMEGA;		// W, Angle from asc. node to perihelion" unit="deg"  
		double INCLINAT;	// IN, Inclination unit="deg" 
		double ECCENTR;		// EC, Eccentricity 
		double ORBEPOCH;	// EPOCH, Epoch of orbital elements unit="Julian days"
		double ORBEQNOX;	// Elements equinox: J2000.0 or B1950.0 unit="years" 
		double DISTANCE;	// Geocentric Distance unit="AU"  
		
		string SCANTYPE;	// Scan astronomical type type="20A"
		string SCANMODE;	// Mapping mode type="20A" 
		string SCANGEOM;	// Scan geometry type="20A" 
		string SCANDIR;		// "scan direction" type="04A" 
		unsigned long SCANLINE;		// "number of lines in a scan" 
		unsigned long SCANRPTS;		// "number of repeats of each scan line" 
		double SCANLEN;		// "(OTF/RASTER) line length" 
		double SCANXVEL;	// "(OTF) tracking rate along line."
		double SCANTIME;	// "(OTF) time for one line" 
		double SCANXSPC;	// "(RASTER) step along line between samples"
		double SCANYSPC;	// "(OTF/RASTER) step between scan/raster lines" 
		double SCANSKEW;	// "(OTF/RASTER) offset in scan direction between lines" 
		double SCANROT;		// "(OTF/RASTER) rotation of user frame meridian wrt basis meridian. measure positive E of N."
		double SCANPAR1;	// "spare scan parameter" 
		double SCANPAR2;	// "another spare scan parameter" 
		string CROCYCLE;	// "CAL/REF/ON loop string" type="20A" 
		boolean ZIGZAG;		// "(OTF/RASTER) Scan in zigzag?"
		
		double TRANDIST;	// "(HOLO) Holography transmitter distance" unit="m" 
		double TRANFREQ;	// "(HOLO) Holography transmitter frequency" unit="Hz" 
		double TRANFOCU; 	// "(HOLO) Holography transmitter offset from prime focus" unit="deg" 
		
		boolean WOBUSED;	// "Wobbler used?"
		double WOBTHROW;	// "Wobbler throw" unit="deg" 
		string WOBDIR;		// "Wobbler throw direction" type="04A"
		float WOBCYCLE; 	// "Wobbler period" unit="s"  
		string WOBMODE;		// "Wobbler mode (SQUARE/TRIANGULAR)" type="20A" 
		string WOBPAT;		// "Wobbler Pattern (e.g. NEG, POS, SYM)"
		
		string PHASE1;		// "Phase 1 description" type="20A"
		string PHASE2;		// "Phase 2 description" type="20A"
		string PHASE3;		// "Phase 3 description" type="20A"
		string PHASE4;		// "Phase 4 description" type="20A"
		string PHASE5;		// "Phase 5 description" type="20A"
		string PHASE6;		// "Phase 6 description" type="20A"
		string PHASE7;		// "Phase 7 description" type="20A"
		string PHASE8;		// "Phase 8 description" type="20A" 
		
		unsigned long NFEBE;			// "Number of FEBEs" 
		
		float PDELTAIA;		// "Accumulated user ptg correction IA" unit="deg"
		float PDELTACA;		// "Accumulated user ptg correction CA" unit="deg" 
		float PDELTAIE;		// "Accumulated user ptg correction IE" unit="deg"
		float FDELTAX;		// Accumulated user focus correction X unit="m"
		float FDELTAY;		// Accumulated user focus correction Y unit="m"
		float FDELTAZ;		// Accumulated user focus correction Z unit="m"
		float FDELTAXT;		// Accumulated user focus correction XTilt unit="deg"
		float FDELTAYT;		// Accumulated user focus correction YTilt unit="deg"
		float FDELTAZT;		// Accumulated user focus correction ZTilt unit="deg"
		float FDELTAIA;		// "Accumulated ptg corr to IA due to focus" unit="deg"
		float FDELTACA;		// "Accumulated ptg corr to CA due to focus" unit="deg"  
		float FDELTAIE;		// "Accumulated ptg corr to IE due to focus" unit="deg"  
		
		float IA;			// "Pointing Coefficient (-P1)"  unit="deg" 
		float IE;			// "Pointing Coefficient (P7)" unit="deg"
		float HASA;			// "Pointing Coefficient" unit="deg"  
		float HACA;			// "Pointing Coefficient" unit="deg"
		float HESE;			// "Pointing Coefficient (P9 was ZFLX)" unit="deg" 
		float HECE;			// "Pointing Coefficient (P8; was ECEC)" unit="deg" 
		float HESA;			// "Pointing Coefficient" unit="deg" 
		float HASA2;		// "Pointing Coefficient" unit="deg" 
		float HACA2;		// "Pointing Coefficient" unit="deg"  
		float HESA2;		// "Pointing Coefficient" unit="deg" 
		float HECA2;		// "Pointing Coefficient" unit="deg" 
		float HACA3;		// "Pointing Coefficient" unit="deg" 
		float HECA3;		// "Pointing Coefficient" unit="deg" 
		float HESA3;		// "Pointing Coefficient" unit="deg" 
		float NPAE;			// "Pointing Coefficient (-P3)" unit="deg" 
		float CA;			// "Pointing Coefficient (-P2)" unit="deg" 
		float AN;			// "Pointing Coefficient (-P5)" unit="deg" 
		float AW;			// "Pointing Coefficient (-P4)" unit="deg" 
		};

	struct SCAN_MBFITS_COLUMNS_TYPE{
		ListOfStrings FEBE;		// "Frontend-backend combination identification" type="68A"
		};

	struct FEBEPAR_MBFITS_HEADER_TYPE{
		string EXTNAME;		// name of this table "FEBEPAR-MBFITS"
		string FEBE;		// "Frontend-backend combination identification" type="68A" 
		unsigned long SCANNUM;		// "Scan number" 
		string DATE_OBS;	// "Scan start in TIMESYS system" type="23A"
		string DEWCABIN;	// "Dewar cabin: CASS_C or NASMYTH_A or NASMYTH_B" type="68A" 
		string DEWRTMOD;	// "Dewar tracking system" type="05A" 
		float DEWUSER;		// "Dewar user angle" unit="Deg"  
		float DEWZERO;		// "Dewar zero angle" unit="Deg" 
		unsigned long FEBEBAND;		// "Maximum number configurable basebands for this FEBE" 
		unsigned long FEBEFEED;		// "Total number of feeds" 
		unsigned long NUSEBAND;		// "Number of BASEBANDs in use"
		unsigned long FDTYPCOD;		// "FEEDTYPE code definition" type="512A" 
		float FEGAIN;		// "Frontend amplifier gain" 
		string SWTCHMOD;	// "Switch mode" type="20A" 
		unsigned long NPHASES;		// "No. of switch phases in a switch" 
		float FRTHRWLO;		// "Phase 1 frequency switching throw" unit="Hz"  
		float FRTHRWHI;		// "Phase 2 frequency switching throw" unit="Hz"  
		float TBLANK;		// "Blank time of backend" unit="s" 
		float TSYNC;		// "Sync. time of backend" unit="s" 
		float IARX;			// "Receiver ptg coef. adds to IA" unit="deg"  
		float IERX; 		// "Receiver ptg coef. adds to IE" unit="deg" 
		float HASARX;		// "Receiver ptg coef. adds to HASA" unit="deg" 
		float HACARX;		// "Receiver ptg coef. adds to HACA" unit="deg" 
		float HESERX;		// "Receiver ptg coef. adds to HESE"  unit="deg" 
		float HECERX;		// "Receiver ptg coef. adds to HECE" unit="deg" 
		float HESARX;		// "Receiver ptg coef. adds to HESA" unit="deg" 
		float HASA2RX;		// "Receiver ptg coef. adds to HASA2" unit="deg" 
		float HACA2RX;		// "Receiver ptg coef. adds to HACA2" unit="deg" 
		float HESA2RX;		// "Receiver ptg coef. adds to HESA2" unit="deg" 
		float HECA2RX;		// "Receiver ptg coef. adds to HECA2" unit="deg" 
		float HACA3RX;		// "Receiver ptg coef. adds to HACA3" unit="deg" 
		float HECA3RX;		// "Receiver ptg coef. adds to HECA3" unit="deg" 
		float HESA3RX;		// "Receiver ptg coef. adds to HESA3" unit="deg" 
		float NPAERX;		// "Receiver ptg coef. adds to NPAE" unit="deg" 
		float CARX;			// "Receiver ptg coef. adds to CA" unit="deg" 
		float ANRX;			// "Receiver ptg coef. adds to AN" unit="deg"
		float AWRX;			// "Receiver ptg coef. adds to AW" unit="deg" 
		};

	/**
	NOTE: starting from MBFITS v1.63.  Rest frequencies
	and sky frequencies (account for doppler shifts) are calculated in 5 groups
	of parameters to be sure calculation is accurate for wideband systems across
	both sidebands.
	– Source rest frequency in the signal band (WCS version code F)
	– Source rest frequency in the image band (WCS version code I)
	– Telescope (sky) frequency in the signal band (WCS version code S)
	– Telescope (sky) frequency in the image band (WCS version code J)
	– Source radial velocity in the rest frame (e.g. LSRK) (WCS version code R)
	
	NOTE: Some of the original keywords in ARRAYDATA_MBFITS_HEADER have a number
	as the first character.  For example, "1CTYP2F".  Variable name
	in C++ cannot start with a number, therefore I have added "X_" to the name.
	1CTYP2F --> X_1CTYP2F
	*/	
	struct ARRAYDATA_MBFITS_HEADER_TYPE{
		string EXTNAME;		// name of this table "ARRAYDATA-MBFITS"
		string FEBE;		// "Frontend-backend combination ID" type="17A" 
		unsigned long BASEBAND;		// "Baseband number" type="J" unit="--" 
		unsigned long SCANNUM;		// "Scan number" type="J" 
		unsigned long OBSNUM;		// "Subscan number" type="J" 
		unsigned long SUBSNUM;		// "Subscan number" type="J" 
		string DATE_OBS;	// "Subscan start in TIMESYS system" type="23A" 
		unsigned long CHANNELS;		// "Number of spec channels for this BASEBAND" type="J"
		unsigned long NUSEFEED;		// "Number of feeds in use for this BASEBAND" type="J"
		double FREQRES;		// "Frequency resolution" type="D" unit="Hz" 
		double BANDWID;		// "Bandwidth of this BASEBAND in the sky/telescope frequency frame" type="D" unit="Hz" 
		string MOLECULE;	// "Main line molecule" type="20A"
		string TRANSITI;	// "Transition" type="20A" 
		double RESTFREQ;	// "Rest frequency of line" type="D" unit="Hz" 
		double SKYFREQ;		// "Sky frequency of the line including all velocity corrections" type="D" unit="Hz" 
		string SIDEBAND;	// "Main sideband (USB/LSB)" type="03A" 
		double SBSEP;		// "Sideband separation including band offsets in the sky/telescope frequency frame" type="D" unit="Hz" 
		string X_2CTYP2;	// "Feed axis (in USEFEED array)" type="08A" 
		unsigned long X_2CRPX2;		// "Axis 2 Ref position = 1" type="J" 
		unsigned long X_2CRVL2;		// "Axis 2 feed index value at this position" type="J" 
		unsigned long X_2CDLT2A;		// "Axis 2 Feed index separation" = 1
		unsigned long X_21CD2A;		// (DEPRECATED - keep for back compatibility) replaced by 2CDLT2A 
		
		string WCSNM2F;		// Axis name type="08A" Frequency description in source rest frame for main sideband
		string X_1CTYP2F;	// Frequency axis for col.2 type="8A" value = "FREQ    ". Axis (1) description for DATA 
		float X_1CRPX2F;	// Ref. channel type="E" 
		double X_1CRVL2F;	// Frequency at ref. channel in rest frame type="D" unit="Hz" 
		double X_1CDLT2F;	// Channel separation" unit="Hz" 
		double X_11CD2F;	// (DEPRECATED - keep for back compatibility) replaced by 1CDLT2F 
		string X_1CUNI2F;	// Unit type="08A" value="Hz"
		string X_1SPEC2F;	// Standard of rest for frequencies type="08A" example="LSRK"
		string X_1SOBS2F;	// Observing frame type="08A". Ref. frame where spectral coordinate has no spatial variation. value="TOPOCENT"  

		string WCSNM2I;		// Axis name type="08A" Frequency description in source rest frame for image sideband
		string X_1CTYP2I;	// Frequency axis for col.2 type="8A" value = "FREQ    ". Axis (1) description for DATA 
		float X_1CRPX2I;	// Ref. channel type="E" 
		double X_1CRVL2I;	// Frequency at ref. channel in rest frame type="D" unit="Hz" 
		double X_1CDLT2I;	// Channel separation" unit="Hz" 
		double X_11CD2I;	// (DEPRECATED - keep for back compatibility) replaced by 1CDLT2F 
		string X_1CUNI2I;	// Unit type="08A" value="Hz"
		string X_1SPEC2I;	// Standard of rest for frequencies type="08A" example="LSRK"
		string X_1SOBS2I;	// Observing frame type="08A". Ref. frame where spectral coordinate has no spatial variation. value="TOPOCENT"  

		string WCSNM2S;		// Axis name type="08A" Frequency description in sky (telescope) frame for main sideband
		string X_1CTYP2S;	// Frequency axis for col.2 type="8A" value = "FREQ    ". Axis (1) description for DATA 
		float X_1CRPX2S;	// Ref. channel type="E" 
		double X_1CRVL2S;	// Frequency at ref. channel in rest frame type="D" unit="Hz" 
		double X_1CDLT2S;	// Channel separation" unit="Hz" 
		double X_11CD2S;	// (DEPRECATED - keep for back compatibility) replaced by 1CDLT2F 
		string X_1CUNI2S;	// Unit type="08A" value="Hz"
		string X_1SPEC2S;	// Standard of rest for frequencies type="08A" example="LSRK"
		string X_1SOBS2S;	// Observing frame type="08A". Ref. frame where spectral coordinate has no spatial variation. value="TOPOCENT"  

		string WCSNM2J;		// Axis name type="08A" Frequency description in sky (telescope) frame for image sideband
		string X_1CTYP2J;	// Frequency axis for col.2 type="8A" value = "FREQ    ". Axis (1) description for DATA 
		float X_1CRPX2J;	// Ref. channel type="E" 
		double X_1CRVL2J;	// Frequency at ref. channel in rest frame type="D" unit="Hz" 
		double X_1CDLT2J;	// Channel separation" unit="Hz" 
		double X_11CD2J;	// (DEPRECATED - keep for back compatibility) replaced by 1CDLT2F 
		string X_1CUNI2J;	// Unit type="08A" value="Hz"
		string X_1SPEC2J;	// Standard of rest for frequencies type="08A" example="LSRK"
		string X_1SOBS2J;	// Observing frame type="08A". Ref. frame where spectral coordinate has no spatial variation. value="TOPOCENT"  

		string WCSNM2R;		// Axis name type="08A" Velocity description in rest frame (e.g. LSR) for heterodyne receivers.
		string X_1CTYP2R;	// Velocity axis for col.2 type="8A" value = "FREQ    ". Axis (1) description for DATA 
		float X_1CRPX2R;	// Ref. channel type="E" 
		double X_1CRVL2R;	// Frequency at ref. channel in rest frame type="D" unit="km/s" 
		double X_1CDLT2R;	// Channel separation" unit="km/s" 
		double X_11CD2R;	// (DEPRECATED - keep for back compatibility) replaced by 1CDLT2F 
		string X_1CUNI2R;	// Unit type="08A" value="km/s"
		string X_1SPEC2R;	// Standard of rest for frequencies type="08A" example="LSRK"
		string X_1SOBS2R;	// Observing frame type="08A". Ref. frame where spectral coordinate has no spatial variation. value="TOPOCENT"  

		float X_1VSOU2R;	// Source velocity in rest frame" type="E" unit="km/s" 
		float X_1VSYS2R;	// Observer vel. in rest frame" type="E" unit="km/s"  in direction of observation at subscan start.
		};

	/**
	The DATAPAR table contains data-associated parameters which change with integration, but not the data itself (in ARRAYDATA). There is 
	one DATAPAR table per FEBE. Parameters common to all subscans are in the SCAN table, and the FEBE setup is in the FEBEPAR table 
	(assumed not to change between subscans). DATAPAR includes

	– Time and coordinate information specific to this subscan and integration
	– interpolated data from the MONITOR table, resampled to the timestamps of the midpoints of the integrations, as given by MIDTIME.
	*/
	struct DATAPAR_MBFITS_HEADER_TYPE{
		string EXTNAME;		// name of this table "DATAPAR-MBFITS"
		unsigned long SCANNUM;		// "Scan number" type="J"
		unsigned long OBSNUM;		// "Subscan number" type="J"
		unsigned long SUBSNUM;		// "Subscan number" type="J"
		string DATE_OBS;	// "Subscan start in TIMESYS system" type="23A" 
		string FEBE;		// "Frontend-backend combination ID" type="17A" 
		double LST;			// "Local apparent sidereal time (obs. start)" type="D" unit="s" 
		string SUBSTYPE;	// "Subscan type" type="04A"
		string OBSTYPE;		// (DEPRECATED - keep for back compatibility) replaced by SUBSTYPE 
		string SCANTYPE;	// "Scan type" type="20A"
		string SCANMODE;	// "Mapping mode" type="20A"
		string SCANDIR;		//"(optional) scan direction" type="04A"
		double SCANLEN;		// "(optional, OTF/RASTER) line length" type="D" unit=""  
		double SCANXVEL;	// "(optional, OTF) tracking rate along line." type="D" unit=""
		double SCANTIME;	// "(optional, OTF) time for one line" type="D" unit=""  
		double SCANXSPC;	// "(optional, RASTER) step along line between samples" type="D" unit=""  
		double SCANYSPC;	// "(optional, OTF/RASTER) step between scan/raster lines" type="D" unit=""  
		double SCANSKEW;	// "(optional, OTF/RASTER) offset in scan direction between lines" type="D" unit=""
		double SCANPAR1;	// "(optional) spare scan parameter" type="D" unit=""  
		double SCANPAR2;	// "(optional) another spare scan parameter" type="D" unit="" 
		string NLNGTYPE; 	// Native system type (longitude) – XLON-SFL (where x takes appropriate values) type="8A".  Use for AZ pattern while tracking RA main coord. Pointing scans and antenna pattern on EQ sources
		string CTYPE1N;		// (DEPRECATED - keep for back compatibility) replaced by NLNGTYPE
		string NLATTYPE; 	// Native system type (latitude) – XLAT-SFL (where x takes appropriate values) type="8A". Use for EL pattern while tracking DEC main coord.  Pointing scans and antenna pattern on EQ sources
		string CTYPE2N;		// (DEPRECATED - keep for back compatibility) replaced by NLATTYPE
		boolean DPBLOCK;	// "Data blocking?" type="L" 
		unsigned long NINTS;// "Number of integrations in block" type="J"  preset="1"
		string OBSTATUS;	// "Subscan ok? (OK/ABORT)" type="10A" 
		boolean WOBCOORD;	// "Coordinates include wobbler offsets?" type="L" 
		};

	struct DATAPAR_MBFITS_COLUMNS_TYPE{
		double MJD;			// "MJD at integration midpoint in TIMESYS system" type="D" unit="Julian day" 
		double LST;			// "Local apparent sidereal time at integration midpoint" type="D" unit="s" 
		double INTEGTIM;	// "Integration time" type="D" unit="s" 
		unsigned long PHASE;// "Integration phase number" type="J"
		double LONGOFF;		// "Long. offset from source in user native frame pixel coords (x)" type="D" unit="deg" 
		double LATOFF;		// "Lat. offset from source in user native frame  pixel coords (y)" type="D" unit="deg" 
		double AZIMUTH;		// "Azimuth (derived) inc. wobbler offsets" type="D" unit="deg" 
		double ELEVATIO;	// "Elevation (derived) inc. wobbler offsets" type="D" unit="deg" 
		double RA;			// "Mean right ascension including wobbler offsets" type="D" unit="deg"
		double DEC;			// "Mean declination including wobbler offsets" type="D" unit="deg"
		double PARANGLE;	// "parralactic angle" type="D" unit="deg"
		double CBASLONG;	// "Commanded long. in astronomical basis frame (defined by CTYPE)" type="D" unit="deg" 
		double CBASLAT;		// "Commanded lat. in astronomical basis frame (defined by CTYPE)" type="D" unit="deg" 
		double BASLONG;		// "Actual long. in astronomical basis frame, inc. wobbler offsets" type="D" unit="deg" 
		double BASLAT;		// "Actual lat. in astronomical basis frame, inc. wobbler offsets" type="D" unit="deg" 
		double ROTANGLE;	// "Angle of array, measured E wrt N in user native frame" type="D" unit="deg" 
		double MCRVAL1;		// "(opt.) body apparent long. in basis system" type="D" unit="deg."
		double MCRVAL2;		// "(opt.) body apparent lat. in basis system" type="D" unit="deg."
		double MLONPOLE;	// "(opt.) longitude of basis celestial pole in" type="D" unit="deg." 
		double MLATPOLE;	// "(opt.) basis latitude of body frame pole" type="D" unit="deg." 
		double DFOCUS_X;	// "(opt.) Commanded focus X offset (subreflector position)" type="D" unit="m" 
		double DFOCUS_Y;	// "(opt.) Commanded focus Y offset (subreflector position)" type="D" unit="m"
		double DFOCUS_Z;	// "(opt.) Commanded focus Z offset (subreflector position)" type="D" unit="m"
		double DPHI_X;		// "(opt.) Commanded Phi X offset (subreflector rotation)" type="D" unit="deg"
		double DPHI_Y;		// "(opt.) Commanded Phi Y offset (subreflector rotation)" type="D" unit="deg"
		double DPHI_Z;		// "(opt.) Commanded Phi Z offset (subreflector rotation)" type="D" unit="deg"
		};

	/**
	Pack all these MBFITS headers and columns into 1 struct for convenient publishing
	and distribution to other components of the system.
	*/
	struct MetadataNotifyBlock{
		PRIMARY_MBFITS_HEADER_TYPE PRIMARY_MBFITS_HEADER;
		SCAN_MBFITS_HEADER_TYPE SCAN_MBFITS_HEADER;
		SCAN_MBFITS_COLUMNS_TYPE SCAN_MBFITS_COLUMNS;
		FEBEPAR_MBFITS_HEADER_TYPE FEBEPAR_MBFITS_HEADER;
		ARRAYDATA_MBFITS_HEADER_TYPE ARRAYDATA_MBFITS_HEADER;
		DATAPAR_MBFITS_HEADER_TYPE DATAPAR_MBFITS_HEADER;
		};

	struct ScheduleNotifyBlock{
		unsigned long qsize_asap;
		unsigned long qsize_scheduled;
		double countdown_until_start;
		double countdown_until_finish;
		};

	struct TLEData {
		string name;
		string line1;
		string line2;
		string date;
		string message;
		};

	interface Scan: ACS::ACSComponent{
		string get_ip(); // to get component host ip
		/**
		Get the complete metadata structure.  During normal operation, this structure will be published on the
		Notification channel and received by handler functions in other classes that are interested.
		*/
		MetadataNotifyBlock get_metadata();
		TLEData get_TLE(in long id) raises (ScanError::httpResponseEx, ScanError::noInternetConnectionEx);
		
		/**
		Addtional get_ functions for debugging sections of the metadata individually
		*/
		SCAN_MBFITS_HEADER_TYPE get_scan_mbfits_header();
		SCAN_MBFITS_COLUMNS_TYPE get_scan_mbfits_columns();
		FEBEPAR_MBFITS_HEADER_TYPE get_febepar_mbfits_header();
		ARRAYDATA_MBFITS_HEADER_TYPE get_arraydata_mbfits_header();
		DATAPAR_MBFITS_HEADER_TYPE get_datapar_mbfits_header();

		/**
		Get current value of the scan counter that is used to generate scan ID number.
		*/
		long get_scan_id_counter();

		/**
		Get ID that was run last in the queue.
		*/
		long get_scan_id_lastrun();

		/**
		Get the quantity of scans in the queue
		*/
		long qsize();

		/**
		Add scan to the queue.   But not run yet.
		*/
		void addScan(in ScheduleParams schedule_params, 
			in AbstractScantypeParams scantype_params, 
			in AbstractTrackingParams tracking_params, 
			in AbstractFrontendParams frontend_params, 
			in AbstractBackendParams backend_params,
			in DataParams data_params);

		/**
		Delete everything in the queue.  While queue is not running.  see cancel() to stop
		a running queue.
		*/
		long clearQueue();

		/**
		Process all Scans in the queue until empty.
		Returns a string result.  The string is a python dictionary serialized in JSON format
		The function / object who receives this string result can use json.loads to 
		re-create the Python dictionary.
		*/
		string run_queue() raises (ScanError::backendsExceptionEx, ScanError::GeneralErrorEx);
		

		/**
		stop running the queue and stop current scan.
		Remaining items in queue are not deleted
		*/
		string stop_queue();
		
		boolean is_current_scan_canceled();
    	boolean is_trackcoord_arrived();
		
		}; // interface

		
        

}; // module
#endif
